// pages/group-details/group-details.js
import httpRequestApi from '../../../utils/APIClient';
import util from '../../../utils/util';
Page({

  /**
   * 页面的初始数据
   */
  data: {
    titleIcon: '',
    title: '',
    bookInfo: '',
    lessonList: [],
    surplusNum: '',
    joinUserList: [],
    surplusList: [],
    timeList: [],
    productId: '',
    groupId: '',
    orderId: ''
  },
  //跳转到年级
  gradeDetails: function () {
    // wx.navigateTo({
    //   url: '/pages/groupPage/grade-details/grade-details'
    // })
    // wx.setNavigationBarTitle({
    //   title: '限量优惠团购'
    // })
  
  },
  //开团
  openGroup: function () {
    const productId = this.data.productId;
    const groupId = this.data.groupId;
    //开始发起团购
    httpRequestApi.SendGroupPurchas({
      productId,
      groupId
    }).success( (res) =>{
      console.log('发起团购',res);
      // wx.navigateTo({
      //   url: `/pages/groupPage/collage-details/collage-details`
      // })
      if(res.data.message) {
        wx.showModal({
          title: '提示',
          content: res.data.message,
          success (res) {
            if (res.confirm) {
              console.log('用户点击确定')
            } else if (res.cancel) {
              console.log('用户点击取消')
            }
          }
        })
        return false;
      }
      //掉起支付
      this.prePayMap(res.data.data.prePayMap, res.data.data.groupPurchaseOrderDetail.orderId);
    }).fail( (error) => {
      
    })
  },
  //参团
  jionGroup: function () {
    const orderId = this.data.orderId;
    //开始发起团购
    httpRequestApi.JoinGroupPurchas(orderId).success( (res) =>{
      console.log('参加团购',res);
      if(res.data.message) {
        wx.showModal({
          title: '提示',
          content: res.data.message,
          success (res) {
            if (res.confirm) {
              console.log('用户点击确定')
            } else if (res.cancel) {
              console.log('用户点击取消')
            }
          }
        })
        return false;
      }
      //掉起支付
      this.prePayMap(res.data.data.prePayMap, res.data.data.groupPurchaseOrderDetail.orderId);
    }).fail( (error) => {
      
    })
  },

  //支付
  prePayMap: function (prePayMap, orderId) {
    console.log(prePayMap)
    const that = this;
    wx.requestPayment(
      {
        'appId': prePayMap.appId,
        'timeStamp': prePayMap.timeStamp,
        'nonceStr': prePayMap.nonceStr,
        'package': prePayMap.package,
        'signType': 'MD5',
        'paySign': prePayMap.sign,
        'success':function(res){
          console.log('支付成功')
          wx.showModal({
            title: '提示',
            content: '支付成功',
            success (res) {
              if (res.confirm) {
                that.popup.close();
                // setTimeout(() => {
                //   wx.navigateTo({
                //     url: `/pages/groupPage/collage-details/collage-details?orderId=${orderId}`
                //   })
                //   wx.setNavigationBarTitle({
                //     title: '拼团详情'
                //   })
                // }, 1000)
              } else if (res.cancel) {
                that.popup.close();
                setTimeout(() => {
                  wx.navigateTo({
                    url: `/pages/groupPage/collage-details/collage-details?orderId=${orderId}`
                  })
                  wx.setNavigationBarTitle({
                    title: '拼团详情'
                  })
                }, 1000)                
              }
            }
          })

        },
        'fail':function(res){
          console.log('支付失败', res)
        }
      })
  },
  //跳转到拼团详情
  collage: function () {

  },
  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    wx.setNavigationBarTitle({
      title: '拼团详情'
    })
    if(!options.productId) return false;
    const productId = options.productId;
    const groupId = options.groupId;
    const orderId = options.id;
    this.setData({
      productId,
      groupId,
      orderId
    })
    //课本详情
    httpRequestApi.getBookDetail(productId).success( (res) =>{
      console.log('课本详情',res.data.data);
      const bookInfo = res.data.data.product;
      const lessonList = res.data.data.lessonList;
      this.setData({
          titleIcon: bookInfo.bgImg,
          title: bookInfo.title,
          bookInfo: bookInfo.description
      })
      const lessonTemp = [];
      lessonList.forEach(item => {
          const temp = {};
          temp.id = item.id;
          temp.title = item.title;
          temp.readNum = item.readCount;
          lessonTemp.push(temp);
      });
      this.setData({
          lessonList: lessonTemp
      });
    }).fail( (error) => {

    })
    //拼团详情
    httpRequestApi.getMygroupInfo(orderId).success( res => {
      console.log('支付详情', res.data.data);
      const surplusNum = res.data.data.groupPurchaseOrder.headcount - res.data.data.groupPurchaseOrder.joinCount;
      for(var i = 0; i < surplusNum; i++) {
        this.data.surplusList.push(1);
      }
      console.log(res.data.data.groupPurchaseOrder.closeTimed - res.data.data.groupPurchaseOrder.gmtCreated)
      //时间转换
      const timeList = util.formatTime(res.data.data.groupPurchaseOrder.closeTimed - res.data.data.groupPurchaseOrder.gmtCreated);
      this.setData({
        surplusNum,
        joinUserList: res.data.data.joinUserList,
        surplusList: this.data.surplusList,
        timeList,
      })
    }).fail( error => {
      console.log('错误', error)
    })
    
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  }
})